import QtQuick 2.4
import Ubuntu.Components 1.2
import QtHalide 0.1

Item {
    id: effectPreview

    property var model
    property bool transformUpdating
    property bool loaded: editorLoader.status == Loader.Ready

    implicitHeight: editorLabel.height + editorLoader.height + units.gu(1) + editorLabel.anchors.bottomMargin

    Rectangle {
        anchors.fill: parent
        color: Qt.rgba(0, 0, 0, 0.5)
    }

    Label {
        id: editorLabel
        anchors {
            left: parent.left
            leftMargin: units.gu(2)
            bottom: editorLoader.top
            bottomMargin: editorLoader.height != 0 ? 0 : units.gu(1)
        }
        text: effectPreview.model ? effectPreview.model.label : ""
        font.bold: true
    }

    ActivityIndicator {
        anchors {
            verticalCenter: editorLabel.verticalCenter
            right: parent.right
            rightMargin: units.gu(2)
        }
        width: units.gu(2)
        height: width
        running: effectPreview.transformUpdating
        opacity: running ? 1.0 : 0.0
        Behavior on opacity { UbuntuNumberAnimation {duration: UbuntuAnimation.BriskDuration} }
    }
    
    Loader {
        id: editorLoader
        anchors {
            bottom: parent.bottom
            right: parent.right
            rightMargin: units.gu(2)
            left: parent.left
            leftMargin: units.gu(2)
        }
        source: effectPreview.model ? effectPreview.model.editor : ""
        asynchronous: true
        onLoaded: {
            item.useValuesFromFunction(effectsGrid.currentLocalFunction);
            item.bindFunction(effectsGrid.currentLocalFunction);
            item.bindFunction(effectsGrid.currentGlobalFunction);
        }
    }
}
