import QtQuick 2.4
import QtHalide 0.1

Item {
    id: transformPreview

    property HalideFunction halideFunction
    property var bindings
    property var changeHandlers: []

    function setFunction(newFunction) {
        unbindFunction(halideFunction);
        halideFunction = newFunction;
        useValuesFromFunction(halideFunction);
        bindFunction(halideFunction);
    }

    function useValuesFromFunction(newFunction) {
        // setup bindings between newFunction and preview
        if (newFunction) {
            for (var key in bindings) {
                var valueProp = bindings[key];
                transformPreview[valueProp] = newFunction[key];
            }
        }
    }

    function bindFunction(newFunction) {
        // setup bindings between newFunction and preview
        if (newFunction) {
            for (var key in bindings) {
                var valueProp = bindings[key];
                newFunction[key] = transformPreview[valueProp];
                var handlerFunction = eval("function () { newFunction['%2'] = transformPreview['%1']; }".arg(valueProp).arg(key));
                changeHandlers[newFunction] = [];
                changeHandlers[newFunction][valueProp] = handlerFunction;
                var connect = "transformPreview.%1Changed.connect(handlerFunction)".arg(valueProp);
                var r = eval(connect);
            }
        }
    }

    function unbindFunction(oldFunction) {
        // break bindings on bound oldFunction
        if (oldFunction) {
            for (var key in bindings) {
                var valueProp = bindings[key];
                var handlerFunction = changeHandlers[oldFunction][valueProp];
                var disconnect = "transformPreview.%1Changed.disconnect(handlerFunction)".arg(valueProp);
                eval(disconnect);
                delete changeHandlers[valueProp];
            }
        }
    }
}
