import QtQuick 2.4
import Ubuntu.Components 1.2

TransformPreview {
    id: transformPreview

    property real minimumValue: -100
    property real maximumValue: 100
    property alias value: slider.value

    function formatValue(v) {
        return v.toFixed(0);
    }

    implicitHeight: slider.implicitHeight

    Slider {
        id: slider
        anchors {
            left: parent.left
            right: parent.right
            bottom: parent.bottom
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }
}
