import QtQuick 2.4
import Ubuntu.Components 1.2

TransformPreview {
    id: transformPreview

    property real minimumValue: 0.0
    property real maximumValue: 1.0
    property alias valueWidth: sliderWidth.value
    property alias valueHeight: sliderHeight.value
    property alias valueX: sliderX.value
    property alias valueY: sliderY.value

    function formatValue(v) {
        return v.toFixed(0);
    }

    implicitHeight: sliderWidth.implicitHeight + sliderHeight.implicitHeight + sliderX.implicitHeight + sliderY.implicitHeight

    Label {
        id: labelWidth
        text: "Width"
        anchors {
            left: parent.left
            verticalCenter: sliderWidth.verticalCenter
        }
    }

    Slider {
        id: sliderWidth
        anchors {
            left: labelWidth.right
            leftMargin: units.gu(2)
            right: parent.right
            bottom: sliderHeight.top
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }

    Label {
        id: labelHeight
        text: "Height"
        anchors {
            left: parent.left
            verticalCenter: sliderHeight.verticalCenter
        }
    }

    Slider {
        id: sliderHeight
        anchors {
            left: labelHeight.right
            leftMargin: units.gu(2)
            right: parent.right
            bottom: sliderX.top
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }

    Label {
        id: labelX
        text: "Start X"
        anchors {
            left: parent.left
            verticalCenter: sliderX.verticalCenter
        }
    }

    Slider {
        id: sliderX
        anchors {
            left: labelX.right
            leftMargin: units.gu(2)
            right: parent.right
            bottom: sliderY.top
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }

    Label {
        id: labelY
        text: "Start Y"
        anchors {
            left: parent.left
            verticalCenter: sliderY.verticalCenter
        }
    }

    Slider {
        id: sliderY
        anchors {
            left: labelY.right
            leftMargin: units.gu(2)
            right: parent.right
            bottom: parent.bottom
        }
        minimumValue: transformPreview.minimumValue
        maximumValue: transformPreview.maximumValue
        live: true
        function formatValue(v) {
            return transformPreview.formatValue(v);
        }
    }
}
