#include <QtQml>
#include <QtQml/QQmlContext>
#include "backend.h"
#include "halide_image.h"
#include "halide_transform.h"
#include "halide_function_list_model.h"
#include "halide_image_renderer.h"
#include "halide_transform_worker.h"

void BackendPlugin::registerTypes(const char *uri)
{
    Q_ASSERT(uri == QLatin1String("QtHalide"));

    qRegisterMetaType< QSharedPointer<HalideImageData> >();
    qRegisterMetaType< QList< QSharedPointer<HalideFunctionData> > >();
    qmlRegisterUncreatableType<HalideFunctionListModel>(uri, 0, 1, "HalideFunctionListModel",
                                                        "Only available via HalideTransform::functions");
    qmlRegisterType<HalideImage>(uri, 0, 1, "HalideImage");
    qmlRegisterType<HalideTransform>(uri, 0, 1, "HalideTransform");
    qmlRegisterType<HalideImageRenderer>(uri, 0, 1, "HalideImageRenderer");
    qmlRegisterType<HalideFunction>(uri, 0, 1, "HalideFunction");
}

void BackendPlugin::initializeEngine(QQmlEngine *engine, const char *uri)
{
    QQmlExtensionPlugin::initializeEngine(engine, uri);
}

