#ifndef HALIDEFUNCTIONLISTMODEL_H
#define HALIDEFUNCTIONLISTMODEL_H

#include <QtCore/QAbstractListModel>
#include <QtCore/QList>
#include "halide_function.h"

class HalideFunctionListModel : public QAbstractListModel
{
    Q_OBJECT

    Q_PROPERTY(int count READ count NOTIFY countChanged)

public:
    enum Roles {
        ModelData = Qt::UserRole + 1,
    };

    HalideFunctionListModel(QObject* parent = 0);

    int count();
    Q_INVOKABLE void clear();
    Q_INVOKABLE HalideFunction* get(int index);
    Q_INVOKABLE void append(HalideFunction* function);
    void append(const QList<HalideFunction*>& functions);
    Q_INVOKABLE void insert(int index, HalideFunction* function);
    Q_INVOKABLE bool remove(int index);
    Q_INVOKABLE bool remove(HalideFunction* function);
    Q_INVOKABLE bool move(int from, int to);
    QList<HalideFunction*> toList();

    // inherited from QAbstractListModel
    virtual QHash<int, QByteArray> roleNames() const;
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;

Q_SIGNALS:
    void countChanged();

private:
    QList<HalideFunction*> m_list;
};

#endif // HALIDEFUNCTIONLISTMODEL_H

