﻿#include "halide_transform_cpu.h"
#include "halide_transform.h"
#include "halide_common.h"

HalideTransformCpu::HalideTransformCpu(HalideTransform* transform) :
    HalideTransformWorker(transform)
{
    this->moveToThread(m_thread);
    m_thread->start();
}

HalideTransformCpu::~HalideTransformCpu()
{
}

QSharedPointer<HalideImageData> HalideTransformCpu::prepareOutputData(QSharedPointer<HalideImageData> oldOutputData, QSize outputSize)
{
    if (outputSize != oldOutputData->size) {
        QSharedPointer<HalideImageData> outputData(new HalideImageData);
        // only reallocate a buffer if necessary
        QImage outputImage;
        Halide::Buffer output_buffer;
        outputImage = QImage(outputSize, QImage::Format_RGBA8888);
        output_buffer = halideBufferFromQImage(outputImage);
        outputData->isPacked = true;
        outputData->image = outputImage;
        outputData->buffer = output_buffer;
        outputData->size = outputSize;
        return outputData;
    } else {
        return oldOutputData;
    }
}
