#ifndef HALIDETRANSFORMOPENGL_H
#define HALIDETRANSFORMOPENGL_H

#include <QtCore/QObject>
#include <QtGui/QOpenGLContext>
#include <QtGui/QOffscreenSurface>
#include "halide_transform_worker.h"

class HalideTransformOpenGL : public HalideTransformWorker
{
    Q_OBJECT

public:
    explicit HalideTransformOpenGL(HalideTransform* transform);
    ~HalideTransformOpenGL();

    virtual bool isReady();
    virtual QSharedPointer<HalideImageData> prepareOutputData(QSharedPointer<HalideImageData> oldOutputData, QSize outputSize);
    virtual void preRender();
    virtual void postRender();

private Q_SLOTS:
    void createOpenGLContext(QOpenGLContext* parentContext);
    void destroyOpenGLContext();
    void createSurface();

private:
    QOpenGLContext* m_context;
    QOffscreenSurface m_surface;
    QOpenGLContext* m_preRenderContext;
    QSurface* m_preRenderSurface;
};

#endif // HALIDETRANSFORMOPENGL_H

