import QtQuick 2.0
import QtTest 1.0

TestCase {
    id: test
    property Item compareTarget

    function compareAllPixelsWithColor(r, g, b, a, message) {
        var pixels = test.grabImage(test.compareTarget)
        test.verify(test.compareTarget.width > 0);
        test.verify(test.compareTarget.height > 0);
        for (var x = 0; x < test.compareTarget.width; x++) {
            for (var y = 0; y < test.compareTarget.height; y++) {
                var pixel = pixels.pixel(x, y);
                var errorMessage = "%1: image(%2,%3): %4,%5,%6,%7; expected: %8,%9,%10,%11"
                                    .arg(message).arg(x).arg(y)
                                    .arg(pixels.red(x, y)).arg(pixels.green(x, y)).arg(pixels.blue(x, y)).arg(pixels.alpha(x, y))
                                    .arg(r).arg(g).arg(b).arg(a);
                test.verify(Qt.colorEqual(pixel, Qt.rgba(r/255, g/255, b/255, a/255)), errorMessage);
            }
        }
    }

    function comparePixelWithColor(x, y, r, g, b, a, message) {
        var pixels = test.grabImage(test.compareTarget);
        var pixel = pixels.pixel(x, y);
        var errorMessage = "%1: image(%2,%3): %4,%5,%6,%7; expected: %8,%9,%10,%11"
                            .arg(message).arg(x).arg(y)
                            .arg(pixels.red(x, y)).arg(pixels.green(x, y)).arg(pixels.blue(x, y)).arg(pixels.alpha(x, y))
                            .arg(r).arg(g).arg(b).arg(a);
        test.verify(Qt.colorEqual(pixel, Qt.rgba(r/255, g/255, b/255, a/255)), errorMessage);
    }
}
