import QtQuick 2.0
import QtTest 1.0
import QtHalide 0.1

SignalSpy {
    id: spy
    signalName: "updatingChanged"
    target: halideTransform
    property TestCase test
    property HalideTransform halideTransform
    property string errorMessage: "HalideTransform emitted 'updatingChanged' more times than expected"

    function waitForUpdate() {
        spy.wait();
        spy.wait();
        spy.test.verify(!halideTransform.updating);
        spy.test.compare(spy.count, 2, errorMessage);
        spy.clear();
    }

    function ensureNoPendingUpdate() {
        spy.test.tryCompare(halideTransform, "updating", false, 1000);
    }
}
