#include <Halide.h>
#include "halide_generators_common.h"

namespace {

class Channel : public HalideGeneratorExtended<Channel> {
public:
    ImageParam input{ Halide::type_of<uint8_t>(), 3, "input" };
    Param<int> channel{ "channel", 0 };

    Func build() override {
        Func function;
        Var x, y, c;
        function(x, y, c) = select(c == 3, cast<uint8_t>(255),
                                   select(c == channel, cast<uint8_t>(255), input(x, y, c)));

        schedule_cpu_and_glsl(this, input, function, x, y, c);

        set_packed(input);
        set_packed(function.output_buffer());

        return function;
    }

};

Halide::RegisterGenerator<Channel> register_channel{"channel"};

}
