#include <Halide.h>
#include "halide_generators_common.h"

namespace {

class UnavailableTypes : public HalideGeneratorExtended<UnavailableTypes> {
public:
    Param<int*> intstar_param{ "intstar_param", 0 };

    Func build() override {
        Func function;
        Var x, y, c;
        function(x, y, c) = select(c < 3, 125, cast<uint8_t>(255));

        set_packed(function.output_buffer());

        return function;
    }

};

Halide::RegisterGenerator<UnavailableTypes> register_unavailable_types{"unavailable_types"};

}
