import QtQuick 2.0
import QtTest 1.0
import QtHalide 0.1
import QtHalideTestHelper 0.1

Item {
    width: 200
    height: 200

    HalideTransform {
        id: transform
        input: HalideImage {
            id: input
            source: "in.png"
        }
    }

    Component {
        id: channelFunctionComponent
        HalideFunction {
            name: "channel"
            property HalideImage input
        }
    }

    HalideImageRenderer {
        id: output
        anchors.centerIn: parent
        width: input.size.width
        height: input.size.height
        image: transform.output
        clip: true
    }

    ComparePixelsTestCase {
        id: test
        name: "FunctionMissingPropertyTest"
        when: windowShown

        compareTarget: output

        // verify no crashes if non-buffer property missing, and output is empty
        function test_missing_property() {
            ignoreWarning("HalideFunction 'channel' is missing property 'channel' of type int.");
            var channelFunction = channelFunctionComponent.createObject(output);
            transform.functions = [channelFunction];
            compare(transform.output.size.width, -1);
            compare(transform.output.size.height, -1);
        }
    }
}

